﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CAS_143564_S2L9Z6
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.DataSource = GetSampleData();
            this.ultraGrid1.DisplayLayout.Bands[0].Columns[1].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            this.ultraGrid1.DisplayLayout.Bands[0].ColHeadersVisible = false;
            this.ultraFormattedTextEditor1.WrapText = false;

        }

        private DataTable GetSampleData()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("<ALL>",typeof(string));
            dt.Columns.Add("State", typeof(bool)).DefaultValue = false;
            dt.Rows.Add(new object[] { "<ALL>" });
            dt.Rows.Add(new object[] {"Movies" });
            dt.Rows.Add(new object[] { "Series-Episodic" });
            dt.Rows.Add(new object[] {  "Series-Modular" });
            dt.Rows.Add(new object[] {"Series-Modular/Episodic" });
            dt.Rows.Add(new object[] { "Specials" });

            return dt;
        }



        private void ultraGrid1_BeforeCellUpdate(object sender, BeforeCellUpdateEventArgs e)
        {
            bool isAllTrue = false;
            if (e.Cell.Column.ToString().Equals("State"))
            {
                StringBuilder builder = new StringBuilder();
                for (int i = 0; i < this.ultraGrid1.Rows.Count; i++)
                {
                    if (this.ultraGrid1.Rows[i].Cells[0].Text == "<ALL>")
                    {
                        if (this.ultraGrid1.Rows[i].Cells[1].Text == "True")
                        {
                            this.ultraFormattedTextEditor1.Text = this.ultraGrid1.Rows[i].Cells[0].Text;
                            this.ultraFormattedTextEditor1.Refresh();
                            isAllTrue = true;
                            break;
                        }
                    }
                    else
                    {
                        if (this.ultraGrid1.Rows[i].Cells[1].Text == "True")
                        {
                            builder.Append(this.ultraGrid1.Rows[i].Cells[0].Text + ", ");
                        }
                        
                    }
                }

                if(!isAllTrue)
                {
                    this.ultraFormattedTextEditor1.Text = builder.ToString();
                }
            }
        }

        private void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
            e.Cell.Row.Update();
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
            e.Layout.Override.RowSelectors = DefaultableBoolean.False;
            e.Layout.Bands[0].HeaderVisible = false;
        }
    }
}
